VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   2550
   ClientLeft      =   2775
   ClientTop       =   2430
   ClientWidth     =   3690
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   2550
   ScaleWidth      =   3690
   Begin VB.CommandButton Command2 
      Caption         =   "Stop"
      Height          =   375
      Left            =   2535
      TabIndex        =   5
      Top             =   1050
      Width           =   975
   End
   Begin VB.VScrollBar VScroll2 
      Height          =   1935
      LargeChange     =   1000
      Left            =   1830
      Min             =   -32768
      SmallChange     =   20
      TabIndex        =   2
      Top             =   375
      Value           =   32767
      Width           =   495
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1935
      LargeChange     =   1000
      Left            =   1350
      Min             =   -32768
      SmallChange     =   20
      TabIndex        =   1
      Top             =   375
      Value           =   32767
      Width           =   495
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   15000
      Left            =   3015
      Top             =   1875
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   375
      Left            =   165
      TabIndex        =   0
      Top             =   1050
      Width           =   975
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Zentriert
      Caption         =   "R"
      Height          =   255
      Left            =   1830
      TabIndex        =   4
      Top             =   135
      Width           =   495
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Zentriert
      Caption         =   "L"
      Height          =   255
      Left            =   1350
      TabIndex        =   3
      Top             =   135
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' berarbeitet im Aug. 2004 durch K. Langbein

Option Explicit


' API-Funktionen:
Private Declare Function mciSendString Lib "winmm.dll" _
                         Alias "mciSendStringA" ( _
                         ByVal lpstrCommand As String, _
                         ByVal lpstrRet As String, _
                         ByVal uReturnLength As Long, _
                         ByVal hwndCallback As Long) As Long

Private Declare Function waveOutSetVolume Lib "winmm.dll" ( _
                         ByVal uDeviceID As Long, _
                         ByVal dwVolume As Long) As Long

Private Type intVolumeType
    Left As Integer
    Right As Integer
End Type

Private Type lngVolumeType
    Value As Long
End Type

Function SignedInteger(ByVal UnsignedInteger As Long) As Integer
    ' Zur Sicherheit werden nur die niederwertigen 2 Byte
    ' bercksichtigt.
    UnsignedInteger = UnsignedInteger And 65535
        
    If (UnsignedInteger And 32768) Then
        ' Wenn das MSB gesetzt ist, subtrahieren wir 65536.
        SignedInteger = UnsignedInteger - 65536
    Else
        ' Ansonsten knnen wir den Wert unverndert bernehmen.
        SignedInteger = UnsignedInteger
    End If
End Function

Sub SetVolume()
    Dim intVol As intVolumeType
    Dim lngVol As lngVolumeType
    
    ' Der Maximalwert der Vscrolls ist 10000. Durch
    ' Multiplizieren mit 6.5535 wird der Maximalwert
    ' zu 65535, was dem Maximum eines vorzeichenlosen
    ' 2-Byte-Integer entspricht.
    
    ' Mit Hilfe der Funktion SignedInteger konvertieren wir
    ' den Sollwert zu einem vorzeichenbehafteten VB-Integer:
    intVol.Left = SignedInteger(VScroll1.Value * 6.5535)
    intVol.Right = SignedInteger(VScroll2.Value * 6.5535)
    
    ' Mit folgendem Befehl kann der Inhalt von intVol in lngVol
    ' bertragen werden. Auf diese Weise knnen wir die zwei
    ' Integer ohne viel Aufhebens zu einem Long zusammenfassen.
    LSet lngVol = intVol

    'Lautstrke einstellen
    Call waveOutSetVolume(0, lngVol.Value)
End Sub

Private Sub Command1_Click()
    Dim lngResult As Long
    Dim strRet As String
    Dim strFile As String

    strRet = Space$(128)
    lngResult = mciSendString("stop sound", strRet, 128, 0&)
    lngResult = mciSendString("close sound", strRet, 128, 0&)

    'Abspielen
    strRet = Space$(128)
    strFile = App.Path & "\test.wav"
    
    lngResult = mciSendString("open waveaudio!" & strFile & _
                              " alias sound", strRet, 128, 0&)
                              
    If lngResult <> 0 Then
        MsgBox lngResult
    End If

    lngResult = mciSendString("play sound", strRet, 128, 0&)
    
    If lngResult <> 0 Then
        MsgBox lngResult
    End If
    
    Timer1.Enabled = True
End Sub

Private Sub Command2_Click()
    Dim lngResult As Long
    Dim strRet As String

    strRet = Space$(128)
    lngResult = mciSendString("stop sound", strRet, 128, 0&)
    lngResult = mciSendString("close sound", strRet, 128, 0&)
    Timer1.Enabled = 0
End Sub


Private Sub Form_Load()
    'Control-Eigenschaften initialisieren

    Label1.Caption = "L"
    Label2.Caption = "R"

    VScroll1.LargeChange = 1000
    VScroll1.Min = 10000
    VScroll1.Max = 0
    VScroll1.Value = 5000

    VScroll2.LargeChange = 1000
    VScroll2.Min = 10000
    VScroll2.Max = 0
    VScroll2.Value = 5000
    Call SetVolume
    Timer1.Enabled = 0
    Timer1.Interval = 17000
End Sub

Private Sub Timer1_Timer()
    Call Command1_Click
End Sub

Private Sub VScroll1_Scroll()
    Call SetVolume
End Sub

Private Sub VScroll2_Scroll()
    Call SetVolume
End Sub

